﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlaneBehaviour : MonoBehaviour {

	public Animator anim;

	public float vSpeed;
	public float hSpeed;

	Rigidbody2D planeRB;

	public bool isDead;

	public int blendShapeCount;
	public SkinnedMeshRenderer skinnedMeshRenderer;
	public Mesh skinnedMesh;
	public float blendOne = 0f;
	public float blendTwo = 0f;
	public float blendSpeed = 1f;
	public bool blendOneFinished = false;

	public float kBack;
	public Collider2D planeCollider;
	public Collider2D planeFrontCol;

	void Awake ()
	{
		skinnedMeshRenderer = GetComponent<SkinnedMeshRenderer> ();
		skinnedMesh = GetComponent<SkinnedMeshRenderer> ().sharedMesh;
	}

	void Start () {
		anim = GetComponent<Animator> ();
		planeRB = GetComponent<Rigidbody2D> ();

		blendShapeCount = skinnedMesh.blendShapeCount; 
	}
	
	void Update () {

		if (isDead == false) {
			float horizontal = Input.GetAxis ("Horizontal") * hSpeed * Time.deltaTime;
			float vertical = Input.GetAxis ("Vertical") * vSpeed * Time.deltaTime;

			planeRB.velocity = new Vector2 (vertical, planeRB.velocity.y);
			planeRB.velocity = new Vector2 (horizontal, planeRB.velocity.x);
		}



		if (isDead == true) {
			Application.LoadLevel ("Main");

			planeRB.gravityScale = 30;
			planeRB.velocity = new Vector2(0,0);
			planeRB.AddForce (new Vector2 (-kBack,kBack));
			planeCollider.enabled = false;
			planeFrontCol.enabled = false;

			if (blendShapeCount > 2) {

				if (blendOne < 100f) {
					skinnedMeshRenderer.SetBlendShapeWeight (0, blendOne);
					blendOne += blendSpeed;
				} else {
					blendOneFinished = true;
				}

				if (blendOneFinished == true && blendTwo < 100f) {
					skinnedMeshRenderer.SetBlendShapeWeight (1, blendTwo);
					blendTwo += blendSpeed;
				}
			}
		}
	







	}
}
